/************************************************************************
 *   IRC - Internet Relay Chat, include/msg.h
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Computing Center
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	__msg_include__
#define __msg_include__

/* Tokenization:
 * Each command must have a TOK_COMMAND and MSG_COMMAND definition.
 * If you don't want one or the other, make them the same.		*/


#define MSG_PRIVATE  "PRIVMSG"	/* PRIV */
#define TOK_PRIVATE  "P"
#define MSG_WHO      "WHO"	/* WHO  -> WHOC */
#define TOK_WHO      "H"
#define MSG_WHOIS    "WHOIS"	/* WHOI */
#define TOK_WHOIS    "W"
#define MSG_WHOWAS   "WHOWAS"	/* WHOW */
#define TOK_WHOWAS   "X"
#define MSG_USER     "USER"	/* USER */
#define TOK_USER     "USER"
#define MSG_NICK     "NICK"	/* NICK */
#define TOK_NICK     "N"
#define MSG_SERVER   "SERVER"	/* SERV */
#define TOK_SERVER   "S"
#define MSG_LIST     "LIST"	/* LIST */
#define TOK_LIST     "LIST"
#define MSG_TOPIC    "TOPIC"	/* TOPI */
#define TOK_TOPIC    "T"
#define MSG_INVITE   "INVITE"	/* INVI */
#define TOK_INVITE   "I"
#define MSG_VERSION  "VERSION"	/* VERS */
#define TOK_VERSION  "V"
#define MSG_QUIT     "QUIT"	/* QUIT */
#define TOK_QUIT     "Q"
#define MSG_SQUIT    "SQUIT"	/* SQUI */
#define TOK_SQUIT    "SQ"
#define MSG_KILL     "KILL"	/* KILL */
#define TOK_KILL     "D"
#define MSG_INFO     "INFO"	/* INFO */
#define TOK_INFO     "F"
#define MSG_LINKS    "LINKS"	/* LINK */
#define TOK_LINKS    "LINKS"
#define MSG_STATS    "STATS"	/* STAT */
#define TOK_STATS    "R"
#define MSG_HELP     "HELP"	/* HELP */
#define TOK_HELP     "HELP"
#define MSG_ERROR    "ERROR"	/* ERRO */
#define TOK_ERROR    "Y"
#define MSG_AWAY     "AWAY"	/* AWAY */
#define TOK_AWAY     "A"
#define MSG_CONNECT  "CONNECT"	/* CONN */
#define TOK_CONNECT  "CN"
#define MSG_UPING    "UPING"    /* UPIN */
#define TOK_UPING    "UP"
#define MSG_MAP      "MAP"      /* MAP  */
#define TOK_MAP      "MAP"
#define MSG_PING     "PING"	/* PING */
#define TOK_PING     "G"
#define MSG_PONG     "PONG"	/* PONG */
#define TOK_PONG     "Z"
#define MSG_OPER     "OPER"	/* OPER */
#define TOK_OPER     "OPER"
#define MSG_PASS     "PASS"	/* PASS */
#define TOK_PASS     "PA"
#define MSG_WALLOPS  "WALLOPS"	/* WALL */
#define TOK_WALLOPS  "WA"
#define MSG_TIME     "TIME"	/* TIME */
#define TOK_TIME     "TI"
#define MSG_SETTIME  "SETTIME"	/* SETT */
#define TOK_SETTIME  "SE"
#define MSG_RPING    "RPING"	/* RPIN */
#define TOK_RPING    "RI"
#define MSG_RPONG    "RPONG"	/* RPON */
#define TOK_RPONG    "RO"
#define MSG_NAMES    "NAMES"	/* NAME */
#define TOK_NAMES    "E"
#define MSG_ADMIN    "ADMIN"	/* ADMI */
#define TOK_ADMIN    "AD"
#define MSG_TRACE    "TRACE"	/* TRAC */
#define TOK_TRACE    "TR"
#define MSG_NOTICE   "NOTICE"	/* NOTI */
#define TOK_NOTICE   "O"
#define MSG_JOIN     "JOIN"	/* JOIN */
#define TOK_JOIN     "J"
#define MSG_PART     "PART"	/* PART */
#define TOK_PART     "L"
#define MSG_LUSERS   "LUSERS"	/* LUSE */
#define TOK_LUSERS   "LUSERS"
#define MSG_MOTD     "MOTD"	/* MOTD */
#define TOK_MOTD     "MO"
#define MSG_MODE     "MODE"	/* MODE */
#define TOK_MODE     "M"
#define MSG_KICK     "KICK"	/* KICK */
#define TOK_KICK     "K"
#define MSG_SERVICE  "SERVICE"	/* SERV -> SRVI */
#define TOK_SERVICE  "SERVICE"
#define MSG_USERHOST "USERHOST"	/* USER -> USRH */
#define TOK_USERHOST "USERHOST"
#define MSG_ISON     "ISON"	/* ISON */
#define TOK_ISON     "ISON"
#define MSG_NOTE     "NOTE"	/* NOTE */
#define	TOK_NOTE     "NO"
#define MSG_SQUERY   "SQUERY"	/* SQUE */
#define TOK_SQUERY   "SQUERY"
#define MSG_SERVLIST "SERVLIST"	/* SERV -> SLIS */
#define TOK_SERVLIST "SERVSET"
#define MSG_SERVSET  "SERVSET"	/* SERV -> SSET */
#define TOK_SERVSET  "SERVSET"
#define	MSG_REHASH   "REHASH"	/* REHA */
#define TOK_REHASH   "REHASH"
#define	MSG_RESTART  "RESTART"	/* REST */
#define TOK_RESTART  "RESTART"
#define	MSG_CLOSE    "CLOSE"	/* CLOS */
#define TOK_CLOSE    "CLOSE"
#define MSG_DIE      "DIE"		/* DIE  */
#define TOK_DIE      "DIE"
#define	MSG_HASH     "HASH"	/* HASH */
#define TOK_HASH     "HASH"
#define	MSG_DNS      "DNS"	/* DNS  -> DNSS */
#define TOK_DNS      "DNS"
#define MSG_SILENCE  "SILENCE"  /* SILE */
#define TOK_SILENCE  "U"
#define MSG_GLINE    "GLINE"    /* GLIN */
#define TOK_GLINE    "GL"
#define MSG_BURST    "BURST"    /* BURS */
#define TOK_BURST    "B"
#define MSG_CREATE   "CREATE"   /* CREA */
#define TOK_CREATE   "C"
#define MSG_END_OF_BURST "END_OF_BURST"  /* END_ */
#define TOK_END_OF_BURST "EB"
#define MAXPARA    15 

extern int m_private(), m_topic(), m_join(), m_part(), m_mode();
extern int m_ping(), m_pong(), m_wallops(), m_kick();
extern int m_nick(), m_error(), m_notice();
extern int m_invite(), m_quit(), m_kill();
extern int m_motd(), m_who(), m_whois(), m_user(), m_list();
extern int m_server(), m_info(), m_links(), m_stats();
extern int m_version(), m_help();
extern int m_squit(), m_away(), m_connect(), m_uping(), m_map();
extern int m_oper(), m_pass(), m_trace();
extern int m_time(), m_settime(), m_rping(), m_rpong(), m_names(), m_admin();
extern int m_lusers(), m_umode(), m_note(), m_close();
extern int m_motd(), m_whowas(), m_silence();
extern int m_service(), m_userhost(), m_ison();
extern int m_gline(), m_servset(), m_servlist(), m_squery();
extern int m_burst(), m_create(), m_end_of_burst();
#if defined(OPER_REHASH) || defined(LOCOP_REHASH)
extern	int	m_rehash();
#endif
#if defined(OPER_RESTART) || defined(LOCOP_RESTART)
extern	int	m_restart();
#endif
#if defined(OPER_DIE) || defined(LOCOP_DIE)
extern	int	m_die();
#endif
extern int m_hash(), m_dns();

#ifdef MSGTAB
struct Message msgtab[] = {
  { MSG_PRIVATE, TOK_PRIVATE, m_private,  0, MAXPARA, 1 ,0L },
  { MSG_NICK,    TOK_NICK,    m_nick,     0, MAXPARA, 1 ,0L },
  { MSG_NOTICE,  TOK_NOTICE,  m_notice,   0, MAXPARA, 1 ,0L },
  { MSG_JOIN,    TOK_JOIN,    m_join,     0, MAXPARA, 1 ,0L },
  { MSG_MODE,    TOK_MODE,    m_mode,     0, MAXPARA, 1 ,0L },
  { MSG_BURST,   TOK_BURST,   m_burst,    0, MAXPARA, 1, 0L },
  { MSG_CREATE,  TOK_CREATE,  m_create,   0, MAXPARA, 1, 0L },
  { MSG_QUIT,    TOK_QUIT,    m_quit,     0, MAXPARA, 1 ,0L },
  { MSG_PART,    TOK_PART,    m_part,     0, MAXPARA, 1 ,0L },
  { MSG_TOPIC,   TOK_TOPIC,   m_topic,    0, MAXPARA, 1 ,0L },
  { MSG_INVITE,  TOK_INVITE,  m_invite,   0, MAXPARA, 1 ,0L },
  { MSG_KICK,    TOK_KICK,    m_kick,     0, MAXPARA, 1 ,0L },
  { MSG_WALLOPS, TOK_WALLOPS, m_wallops,  0, MAXPARA, 1 ,0L },
  { MSG_PING,    TOK_PING,    m_ping,     0, MAXPARA, 1 ,0L },
  { MSG_PONG,    TOK_PONG,    m_pong,     0, MAXPARA, 1 ,0L },
  { MSG_ERROR,   TOK_ERROR,   m_error,    0, MAXPARA, 1 ,0L },
  { MSG_KILL,    TOK_KILL,    m_kill,     0, MAXPARA, 1 ,0L },
  { MSG_USER,    TOK_USER,    m_user,     0, MAXPARA, 1 ,0L },
  { MSG_AWAY,    TOK_AWAY,    m_away,     0, MAXPARA, 1 ,0L },
  { MSG_ISON,    TOK_ISON,    m_ison,     0, 1, 1 ,0L },
  { MSG_SERVER,  TOK_SERVER,  m_server,   0, MAXPARA, 1 ,0L },
  { MSG_SQUIT,   TOK_SQUIT,   m_squit,    0, MAXPARA, 1 ,0L },
  { MSG_WHOIS,   TOK_WHOIS,   m_whois,    0, MAXPARA, 1 ,0L },
  { MSG_WHO,     TOK_WHO,     m_who,      0, MAXPARA, 1 ,0L },
  { MSG_WHOWAS,  TOK_WHOWAS,  m_whowas,   0, MAXPARA, 1 ,0L },
  { MSG_LIST,    TOK_LIST,    m_list,     0, MAXPARA, 1 ,0L },
  { MSG_NAMES,   TOK_NAMES,   m_names,    0, MAXPARA, 1 ,0L },
  { MSG_USERHOST,TOK_USERHOST,m_userhost, 0, 1, 1 ,0L },
  { MSG_TRACE,   TOK_TRACE,   m_trace,    0, MAXPARA, 1 ,0L },
  { MSG_PASS,    TOK_PASS,    m_pass,     0, MAXPARA, 1 ,0L },
  { MSG_LUSERS,  TOK_LUSERS,  m_lusers,   0, MAXPARA, 1 ,0L },
  { MSG_TIME,    TOK_TIME,    m_time,     0, MAXPARA, 1 ,0L },
  { MSG_SETTIME, TOK_SETTIME, m_settime,  0, MAXPARA, 1 ,0L },
  { MSG_RPING,   TOK_RPING,   m_rping,    0, MAXPARA, 1 ,0L },
  { MSG_RPONG,   TOK_RPONG,   m_rpong,    0, MAXPARA, 1 ,0L },
  { MSG_OPER,    TOK_OPER,    m_oper,     0, MAXPARA, 1 ,0L },
  { MSG_CONNECT, TOK_CONNECT, m_connect,  0, MAXPARA, 1 ,0L },
  { MSG_UPING,   TOK_UPING,   m_uping,    0, MAXPARA, 1 ,0L },
  { MSG_MAP,     TOK_MAP,     m_map,      0, MAXPARA, 1 ,0L },
  { MSG_VERSION, TOK_VERSION, m_version,  0, MAXPARA, 1 ,0L },
  { MSG_STATS,   TOK_STATS,   m_stats,    0, MAXPARA, 1 ,0L },
  { MSG_LINKS,   TOK_LINKS,   m_links,    0, MAXPARA, 1 ,0L },
  { MSG_ADMIN,   TOK_ADMIN,   m_admin,    0, MAXPARA, 1 ,0L },
  { MSG_HELP,    TOK_HELP,    m_help,     0, MAXPARA, 1 ,0L },
  { MSG_INFO,    TOK_INFO,    m_info,     0, MAXPARA, 1 ,0L },
  { MSG_MOTD,    TOK_MOTD,    m_motd,     0, MAXPARA, 1 ,0L },
  { MSG_CLOSE,   TOK_CLOSE,   m_close,    0, MAXPARA, 1 ,0L },
  { MSG_SILENCE, TOK_SILENCE, m_silence,  0, MAXPARA, 1 ,0L },
  { MSG_GLINE,	 TOK_GLINE,   m_gline,    0, MAXPARA, 1 ,0L },
  { MSG_END_OF_BURST, TOK_END_OF_BURST, m_end_of_burst, 0, MAXPARA, 1, 0L },
  { MSG_NOTE,    TOK_NOTE,    m_note,     0, 1, 1 ,0L },
#undef USE_SERVICES
#ifdef USE_SERVICES
  { MSG_SERVICE, TOK_SERVICE, m_service,  0, MAXPARA, 1 ,0L },
  { MSG_SERVSET, TOK_SERVSET, m_servset,  0, MAXPARA, 1 ,0L },
  { MSG_SQUERY,  TOK_SQUERY,  m_squery,   0, MAXPARA, 1 ,0L },
  { MSG_SERVLIST,TOK_SERVLIST,m_servlist, 0, MAXPARA, 1 ,0L },
#endif
  { MSG_HASH,    TOK_HASH,    m_hash,     0, MAXPARA, 1 ,0L },
  { MSG_DNS,     TOK_DNS,     m_dns,      0, MAXPARA, 1 ,0L },
#if defined(OPER_REHASH) || defined(LOCOP_REHASH)
  { MSG_REHASH,  TOK_REHASH,  m_rehash,   0, MAXPARA, 1 ,0L },
#endif
#if defined(OPER_RESTART) || defined(LOCOP_RESTART)
  { MSG_RESTART, TOK_RESTART, m_restart,  0, MAXPARA, 1 ,0L },
#endif
#if defined(OPER_DIE) || defined(LOCOP_DIE)
  { MSG_DIE, TOK_DIE, m_die,  0, MAXPARA, 1 ,0L },
#endif
  { (char *) 0, (char *) 0, (int (*)()) 0 , 0, 0, 0, 0L}
};
#else
extern struct Message msgtab[];
#endif
#endif /* __msg_include__ */
